//+------------------------------------------------------------------+
//|                                              iMAOnArray_Test.mq4 |
//|                                                         omelette |
//|                                           omelette@oceanfree.net |
//+------------------------------------------------------------------+
#property copyright "omelette"
#property link      "omelette@oceanfree.net"

#property indicator_separate_window
#property indicator_buffers 3
extern int MA_Period = 14;
extern int MAvg_Period = 5;
extern int MA_Type = 0;  //  0=SMA, 1=EMA, 2=SMMA, 3=LWMA
double MAbuffer[],MAvgBuffer1[],MAvgBuffer2[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
IndicatorBuffers(3);
SetIndexBuffer(0,MAbuffer);
SetIndexBuffer(1,MAvgBuffer1);
SetIndexBuffer(2,MAvgBuffer2);
SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,0,Blue);
SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,0,Gray);
SetIndexStyle(2,DRAW_LINE,STYLE_SOLID,0,Green);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
//----
      if (counted_bars < 0)
       return;
      else counted_bars++;
      
      if (counted_bars < MA_Period)
       int limit = Bars - MA_Period - 1;
      else limit = Bars - counted_bars;
      
      for (int i=limit; i>=0; i--)
      {
       MAbuffer[i] = iMA(NULL,0,MA_Period,0,MODE_SMA,PRICE_CLOSE,i);
       MAvgBuffer1[i] = My_MAOnArray(MAbuffer,i,MAvg_Period,MA_Type); // 'My_MAOnArray' used to calc. MA of MAbuffer in 'main' loop
      }                                                               // note the built-in iMAOnArray will not work here
      for (i=limit; i>=0; i--)
      {
      MAvgBuffer2[i] = iMAOnArray(MAbuffer,0,MathMin(Bars-MA_Period-i,MAvg_Period),0,MA_Type,i); // here built-in iMAOnArray will work because
      }                                                                                          // MAbuffer has already been populated
//----
   return(0);
  }
double My_MAOnArray(double Array[], int Start, int Count, int MA_Type)

{
   double TempArray[],Avg;
   
   ArraySetAsSeries(TempArray,true);
   ArrayResize(TempArray,Count);
   
   for (int i=Count; i>=0; i--)
    TempArray[i] = Array[Start + i];  
   
   Avg = iMAOnArray(TempArray,0,Count,0,MA_Type,0);
 
   return(Avg);
}   
//+------------------------------------------------------------------+